QGIS Application - Bug report #14209
"Save as..." does not work for rasters
2016-02-01 06:51 AM - Alexander Bruy

Status: Closed

Priority: Severe/Regression
Assignee:

Category: Rasters

Affected QGIS version:master
Operating System: all

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 22211

Description
To reproduce
1. start QGIS and load landcover.img from Alaska dataset

2. from layer context menu choose "Save as..." and try to save raster in GeoTiff format
3. saving failed, output layer can not be loadded in QGIS with message

Raster layer: /tmp/test.tif is not a supported raster data source

(src/app/qgisapp.cpp : 10501 : addRasterLayers)

In console | see this

src/core/qgsproviderregistry.cpp: 462: (function) [Oms] Library name is
/home/alex/devel/cpp/qgis/build/output/lib/qgis/plugins/libgdalprovider.so
src/providers/gdal/ggsgdalprovider.cpp: 2754: (create) [0ms] create options:
ERROR 1: Attempt to create 0x0 dataset is illegal,sizes must be larger than zero.

src/providers/gdal/ggsgdalprovider.cpp: 2764: (create) [1ms] Cannot create new dataset /tmp/test.tif:

Attempt to create 0x0 dataset is illegal,sizes must be larger than zero.
src/providers/gdal/ggsgdalproviderbase.cpp: 29: (QgsGdalProviderBase) [Oms] Entered
src/providers/gdal/ggsgdalprovider.cpp: 227: (~QgsGdalProvider) [0ms] entering.
src/core/qgsproviderregistry.cpp: 462: (function) [Oms] Library name is
/home/alex/devel/cpp/qgis/build/output/lib/qgis/plugins/libgdalprovider.so

ERROR 4: /tmp/test.tif' does not exist in the file system,
and is not recognised as a supported dataset name.

It works fine in 2.12, but fails in master.

Associated revisions

Revision 8fc40564 - 2016-03-15 03:12 AM - Nyall Dawson

Default to layer CRS in raster save as dialog (fix #14209)

Revision 25ac01aa - 2016-03-15 03:14 AM - Nyall Dawson

Default to layer CRS in raster save as dialog (fix #14209)

(cherry-picked from 8fc405648be18870133e318cbfc7cb0918efedb1)
http://qgis.org/downloads/data/qgis_sample_data.zip

History

#1 - 2016-02-01 07:02 AM - Luigi Pirelli

confirmed with the following revision commit:beaa45e

src/providers/gdal/qgsgdalprovider.cpp: 2480: (bandStatistics) [0Oms] STDDEV 3.03972
src/core/qgsproviderregistry.cpp: 462: (function) [Oms] Library name is
/home/ginetto/PROGRAMMING/QGIS-Boundless/build/output/lib/qgis/plugins/libgdalprovider.so
src/providers/gdal/qgsgdalprovider.cpp: 2754: (create) [0ms] create options:

ERROR 1: Attempt to create 0x0 dataset is illegal,sizes must be larger than zero.
src/providers/gdal/qgsgdalprovider.cpp: 2764: (create) [0Oms] Cannot create new dataset /home/ginetto/Downloads/pippo.tif:
Attempt to create 0x0 dataset is illegal,sizes must be larger than zero.
src/providers/gdal/qgsgdalproviderbase.cpp: 29: (QgsGdalProviderBase) [0ms] Entered
src/providers/gdal/qgsgdalprovider.cpp: 227: (~QgsGdalProvider) [1ms] entering.
src/core/qgsproviderregistry.cpp: 462: (function) [Oms] Library name is
/home/ginetto/PROGRAMMING/QGIS-Boundless/build/output/lib/qgis/plugins/libgdalprovider.so
ERROR 4: /home/ginetto/Downloads/pippo.tif' does not exist in the file system,

and is not recognised as a supported dataset name.

#2 - 2016-02-03 01:05 AM - Radim Blazek
- Assignee deleted (Radim Blazek)

| found the raster save as dialog pretty broken. CRS and size/resolution are not set correctly by default, which results for example in "Attempt to create 0x0

dataset".

#3 - 2016-02-03 03:39 AM - Nyall Dawson

Radim - looks ok to me. What circumstances do you see the incorrect values?

#4 - 2016-02-03 05:13 AM - Alexander Bruy
- File saveas.png added

Also looks fine here. Extent, CRS and size set correctly. Screenshoot attached.

#5 - 2016-02-03 05:51 AM - Radim Blazek

| have Settings > Options > CRS > Don't enable 'on the fly' reprojection

If I add landcover.img (EPSG 2964, 3663x1964, resolution 3280) and open save as, it is set to:
CRS: EPSG 4326

Extent: -179.96750606303607, 49.18115186042209, 179.99678395391788, 71.42336747479702
Resolution 3280, 3280

Size: 0,0

It should be set to the original raster values. In any case, extent is in EPSG 4326 while resolution in EPSG 2964, that is also why the size is 0xO0.
Alexander Bruy wrote:

Also looks fine here. Extent, CRS and size set correctly. Screenshoot attached.

Correctly? Is not the size 0x0? Does not that fail with "Attempt to create 0x0 dataset"?

#6 - 2016-02-03 08:02 PM - Nyall Dawson

Does this happen every time for you? | can't reliably reproduce it. For me (with OTF off) it defaults to the project CRS, and the derived values are correctly
set.

I'm not sure if the dialog should default to the layer CRS or project CRS, but that's a different discussion....

#7 - 2016-02-04 01:42 AM - Radim Blazek

Playing with landcover.img, | found more serious #14229.

Nyall Dawson wrote:

Does this happen every time for you? | can't reliably reproduce it. For me (with OTF off) it defaults to the project CRS, and the derived values are

correctly set.

Excent/resolution/size are initially wrong only if project is in geographic CRS. If you switch then manually in save as dialog to another (or even to the same)

CRS, the values are corrected.

I'm not sure if the dialog should default to the layer CRS or project CRS, but that's a different discussion....

| believe that default should be layer's CRS, extent and size, otherwise data are lost and that should only happen intentionally (manually select). Apart

loosing data, it can also result in huge output raster, take for example our example, if output CRS for landcover.img is set to epsg:4326, it calculates
resolution 0.000951617,0.0126326 and size 378266,1761! Hardly useful.

#8 - 2016-03-14 07:13 PM - Nyall Dawson
- Status changed from Open to Closed

Fixed in changeset commit:"8fc405648be18870133e318cbfc7cb0918efe4b1".

#9 - 2016-03-14 07:15 PM - Nyall Dawson

Should be fixed with #14392, and the above commit switches the default CRS to match the layer CRS rather than the project CRS.

Files

saveas.png 69.3 KB 2016-02-03 Alexander Bruy
